Entities/Plane.cs
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace AirWaze.Entities
{
    public class Plane
    {
        [Key]
        public int PlaneID { get; set; }
        public string PlaneNr { get; set; }

        public Airline CurrentAirline { get; set; }

        public int PassengerCapacity { get; set; }

        public decimal FuelCapacity { get; set; }

        public string Type { get; set; }

        public string Manufacturer { get; set; }

        public string FlightRegion { get; set; }

        public int FirstClassCapacity { get; set; }

        public decimal LoadCapacity { get; set; }

        public decimal FuelUsagePerKM { get; set; }
        
        public bool IsAvailable { get; set; }
        
        public string? SeatDiagramPic { get; set; }
        
        public DateTime ConstructionYear { get; set; }
        
        public int AirMiles { get; set; }
       
        public int FlightHours { get; set; }
        
        public int NextMainentance { get; set; }
    }
}

Controllers/PlaneController.cs
using AirWaze.Database.Design;
using AirWaze.Entities;
using AirWaze.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Globalization;

namespace AirWaze.Controllers
{
    public class PlaneController : Controller
    {

        private IAirWazeDatabase _myDatabase;

        public static List<PlaneCreateViewModel> planesToAdd = new List<PlaneCreateViewModel>();
              
        public static List<Plane> planeEntities = new List<Plane>();

        private static List<Airline> airlineEntities = new List<Airline>();

        private static List<string> regionList = new List<string>
        {
            "EUR","NA","SA","ASI","ME","AF","OC"
        };

        public static Airline LoggedInAirline;

        //Gets All Entities of Planes - Will do For all uses!
        public PlaneController(IAirWazeDatabase mydatabase)
        {
            List<Plane> oldlist = planeEntities.ToList();
            if (_myDatabase == null)
            {
                _myDatabase = mydatabase;               
            }
            planeEntities = _myDatabase.GetPlanes();
            foreach (Plane x in planeEntities)
            {
                foreach (Plane y in oldlist)
                {
                    if (x.PlaneID == y.PlaneID)
                    {
                        if (x.IsAvailable != y.IsAvailable)
                        {
                            x.IsAvailable = y.IsAvailable;
                            //_myDatabase.UpdatePlane(x);
                        }
                    }
                }
            }
            airlineEntities = _myDatabase.GetAirlines();
        }

        [Authorize(Roles = "Airline")]
        // AIRLINE ROLE
        [HttpGet]
        public async Task<IActionResult> Index(Guid ID, string searchString, string option)
        {
            ViewData["CurrentFilter"] = searchString;
            LoggedInAirline = airlineEntities.FirstOrDefault(x => x.AirlineID == ID);
            if (LoggedInAirline == null)
            {

                LoggedInAirline = new Airline
                {
                    Name = "RyanAir",
                };
                LoggedInAirline =  airlineEntities.FirstOrDefault(x => x.Name == LoggedInAirline.Name);
               
            }

            if (LoggedInAirline.CurrentPlanes == null)
            {
                LoggedInAirline.CurrentPlanes = new List<Plane>();
            }
            List<Plane> planelistAirline = new List<Plane>();
            foreach (Plane x in planeEntities)
            {
                if (x.CurrentAirline.AirlineID == LoggedInAirline.AirlineID) 
                {
                    planelistAirline.Add(x);
                }
            }                 
            List<PlaneListViewModel> thislist = new List<PlaneListViewModel>();
            foreach (var plane in planelistAirline)
            {
               thislist.Add(new PlaneListViewModel()
                {
                    PlaneNr = plane.PlaneNr,
                    CurrentAirline = plane.CurrentAirline,
                    PassengerCapacity = plane.PassengerCapacity,
                    FlightRegion = plane.FlightRegion,
                    IsAvailable = plane.IsAvailable,
                    Manufacturer = plane.Manufacturer,
                    Type = plane.Type,
                    AirMiles = plane.AirMiles,
                    ConstructionYear = plane.ConstructionYear,
                    FlightHours = plane.FlightHours,
                    NextMainentance = plane.NextMainentance,
                }) ;
            }
            //searchfunction
            var myPlane = from s in thislist
                          select s;

            if (!String.IsNullOrEmpty(searchString))
            {
                if (option == "Name")
                {
                    myPlane = myPlane.Where(s => s.PlaneNr.Contains(searchString));
                }
                else if (option == "Type")
                {
                    myPlane = myPlane.Where(s => s.Type.Contains(searchString));
                }
                else if (option == "Capacity")
                {
                    myPlane = myPlane.Where(s => s.PassengerCapacity.ToString().Contains(searchString)).ToList();
                }
                else if (option == "Date")
                {
                    myPlane = myPlane.Where(s => s.ConstructionYear.ToString("dd/MM/yyyy").Contains(searchString) || s.ConstructionYear.ToString("dd-MM-yyyy").Contains(searchString)).ToList();
                }
            }
            return View(myPlane.ToList());

            //return View(thislist);
        }

        [Authorize(Roles = "Admin")]

        //ADMIN ROLE
        public async Task<IActionResult> List(string option, string searchString)
        {
            ViewData["CurrentFilter"] = searchString;
            List<PlaneListViewModel> thislist = new List<PlaneListViewModel>();
            foreach (var plane in planeEntities)
            {
                thislist.Add(new PlaneListViewModel()
                {
                    PlaneNr = plane.PlaneNr,
                    CurrentAirline = plane.CurrentAirline,
                    PassengerCapacity = plane.PassengerCapacity,
                    FlightRegion = plane.FlightRegion,
                    IsAvailable = plane.IsAvailable,
                    Manufacturer = plane.Manufacturer,
                    Type = plane.Type,
                    AirMiles = plane.AirMiles,
                    ConstructionYear = plane.ConstructionYear,
                    FlightHours = plane.FlightHours,
                    NextMainentance = plane.NextMainentance,
                });
            }
            //searchfunction
            var myPlane = from s in thislist
                          select s;

            if (!String.IsNullOrEmpty(searchString))
            {
                if (option == "Name")
                {
                    myPlane = myPlane.Where(s => s.PlaneNr.Contains(searchString));
                }
                else if (option == "Type")
                {
                    myPlane = myPlane.Where(s => s.Type.Contains(searchString));
                }
                else if (option == "Capacity")
                {
                    myPlane = myPlane.Where(s => s.PassengerCapacity.ToString().Contains(searchString)).ToList();
                }
                else if (option == "Date")
                {
                    myPlane = myPlane.Where(s => s.ConstructionYear.ToString("dd/MM/yyyy").Contains(searchString) || s.ConstructionYear.ToString("dd-MM-yyyy").Contains(searchString)).ToList();
                }
            }
            return View(myPlane.ToList());
        }

        [Authorize(Roles = "Admin")]
        //ADMIN
        [HttpGet]
        public IActionResult Create()
        {
            var planeCreateViewModel  = new PlaneCreateViewModel();
            if (planesToAdd.Count != 0)
            {
                planeCreateViewModel = planesToAdd[0];
            }
                      
            return View(planeCreateViewModel);
        }

        [Authorize(Roles = "Airline, Admin")]
        //Airline
        [HttpGet]
        public IActionResult AddPlane(Airline ID)
        {
            var planeCreateViewModel = planesToAdd[0];
            planeCreateViewModel.CurrentAirline = ID;
            return View(planeCreateViewModel);
        }

        [Authorize(Roles = "Admin, Airline")]
        //AIRLINE + ADMIN
        [AutoValidateAntiforgeryToken]
        [HttpPost]
        public async Task<IActionResult> Create(PlaneCreateViewModel planeViewModel)
        {
            await Task.Delay(1500);
            if (LoggedInAirline == null)
            {

                LoggedInAirline = new Airline
                {
                    Name = "AirWazeAir",
                };
                LoggedInAirline = airlineEntities.FirstOrDefault(x => x.Name == LoggedInAirline.Name);
                if (LoggedInAirline == null)
                {
                    LoggedInAirline = new Airline
                    {
                        Name = "AirWazeAir",
                    };
                    LoggedInAirline.CurrentPlanes = new List<Plane>();
                }                
            }
            else if (LoggedInAirline.CurrentPlanes == null)
            {
                LoggedInAirline.CurrentPlanes = new List<Plane>();
            }
            planeViewModel.CurrentAirline = LoggedInAirline;
            var isValid = TryValidateModel(planeViewModel);
            Random generator = new Random();
            if (isValid)
            {
                //UniqueCOmbo with Meaning

                string tempPlaneNr = planeViewModel.Type + "-"  + planeViewModel.CurrentAirline.NameTag + "-" + planeViewModel.FlightRegion + generator.Next(0,1000).ToString();
                var newEntity = new Plane
                {
                    
                    PlaneNr = tempPlaneNr,
                    FlightRegion = planeViewModel.FlightRegion,      
                    CurrentAirline = planeViewModel.CurrentAirline,
                    PassengerCapacity = planeViewModel.PassengerCapacity,
                    FuelUsagePerKM = planeViewModel.FuelUsagePerKM,
                    FirstClassCapacity = planeViewModel.FirstClassCapacity,                   
                    FuelCapacity = planeViewModel.FuelCapacity,
                    IsAvailable = planeViewModel.IsAvailable,
                    LoadCapacity = planeViewModel.LoadCapacity,
                    Manufacturer = planeViewModel.Manufacturer,
                    Type = planeViewModel.Type  ,
                    SeatDiagramPic = planeViewModel.SeatDiagramPic,
                    AirMiles = planeViewModel.AirMiles,
                    ConstructionYear = planeViewModel.ConstructionYear,
                    FlightHours = planeViewModel.FlightHours,

Views/Plane/AddPlane.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}
@model PlaneCreateViewModel

<head>
    <link rel="stylesheet" href="~/css/planecreate.css">
</head>
<div style="padding-top:200px;"></div>
<form asp-controller="Plane" asp-action="Create" method="post">
    <div class="form-group" >
        <label asp-for="Type"></label>
        <input class ="form-control" asp-for="Type" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="Type"></span>
    </div>
    
    <div class="form-group">
        <label asp-for="Manufacturer" ></label>
        <input class ="form-control" asp-for="Manufacturer" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="Manufacturer"></span>
    </div>
    <div class="form-group"  hidden="hidden">
        <label asp-for="SeatDiagramPic" ></label>
        <input class ="form-control" asp-for="SeatDiagramPic" />
        <span class="text-danger" asp-validation-for="SeatDiagramPic"></span>
    </div>
    <div class="form-group">
        <label asp-for="PassengerCapacity"></label>
        <input class ="form-control" asp-for="PassengerCapacity" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="PassengerCapacity"></span>
    </div> 
    <div class="form-group">
        <label asp-for="FirstClassCapacity"></label>
        <input class ="form-control" asp-for="FirstClassCapacity" readonly="readonly" />
        <span class="text-danger" asp-validation-for="FirstClassCapacity"></span>
    </div>
    <div class="form-group">
        <label asp-for="FuelCapacity">Fuel Capacity in Liters</label>
        <input class ="form-control" asp-for="FuelCapacity" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="FuelCapacity"></span>
    </div>
    
    <div class="form-group">
        <label asp-for="LoadCapacity">Load Capacity in Kg</label>
        <input class ="form-control" asp-for="LoadCapacity" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="LoadCapacity"></span>
    </div>
    <div class="form-group">
        <label asp-for="FuelUsagePerKM">Fuel Usage Liters/KM</label>
        <input class ="form-control" asp-for="FuelUsagePerKM" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="FuelUsagePerKM"></span>
    </div>
    <div class="form-group">
        <label asp-for="FlightRegion"></label>
        <input class ="form-control" asp-for="FlightRegion" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="FlightRegion"></span>
    </div>
     <div class="form-group">
        <label asp-for="ConstructionYear"></label>
        <input class ="form-control" asp-for="ConstructionYear" />
        <span class="text-danger" asp-validation-for="ConstructionYear"></span>
    </div>
    <div class="form-group">
        <label asp-for="AirMiles">Km in the Air for this Airport</label>
        <input class ="form-control" asp-for="AirMiles" />
        <span class="text-danger" asp-validation-for="AirMiles"></span>
    </div>
    <div class="form-group" hidden="hidden">
        <label asp-for="FlightHours"></label>
        <input class ="form-control" asp-for="FlightHours" />
        <span class="text-danger" asp-validation-for="AirMiles"></span>
    </div>
     <div class="form-group" hidden="hidden">
        <label asp-for="NextMainentance"></label>
        <input class ="form-control" asp-for="NextMainentance" />
        <span class="text-danger" asp-validation-for="NextMainentance"></span>
    </div>
       <div class="form-group">
        <input asp-for="IsAvailable"/>
        <label asp-for="IsAvailable">Currently Available?</label>
    
    </div>
    

    <button class="btn btn-secondary" type="submit" onclick="message()" style="margin-top:50px;margin-left:40%;width:400px;">Create</button> 
</form>

<script type="text/javascript">
        function message()
        {
            Swal.fire({                   
                    position: 'center',
                    icon: 'success',
                    title: 'Plane Added',
                    showConfirmButton: false,
                    timer: 1500                   
                    });
        }
    </script>

Views/Plane/Create.cshtml
@model PlaneCreateViewModel

<head>
    <link rel="stylesheet" href="~/css/planecreate.css">
</head>
<div style="padding-top:200px;"></div>
<form asp-controller="Plane" asp-action="Create" method="post">
    <div class="form-group" >
        <label asp-for="Type"></label>
        <input class ="form-control" asp-for="Type" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="Type"></span>
    </div>
    
    <div class="form-group">
        <label asp-for="Manufacturer" ></label>
        <input class ="form-control" asp-for="Manufacturer" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="Manufacturer"></span>
    </div>
    <div class="form-group"  hidden="hidden">
        <label asp-for="SeatDiagramPic" ></label>
        <input class ="form-control" asp-for="SeatDiagramPic" />
        <span class="text-danger" asp-validation-for="SeatDiagramPic"></span>
    </div>
    <div class="form-group">
        <label asp-for="PassengerCapacity"></label>
        <input class ="form-control" asp-for="PassengerCapacity" readonly="readonly"/>
        <span class="text-danger" asp-validation-for="PassengerCapacity"></span>
    </div> 
    <div class="form-group">
        <label asp-for="FirstClassCapacity"></label>
        <input class ="form-control" asp-for="FirstClassCapacity" readonly="readonly" />
        <span class="text-danger" asp-validation-for="FirstClassCapacity"></span>
    </div>
    <div class="form-group">
        <label asp-for="FuelCapacity">Fuel Capacity in Liters</label>
        <input class ="form-control" asp-for="FuelCapacity" />
        <span class="text-danger" asp-validation-for="FuelCapacity"></span>
    </div>
    
    <div class="form-group">
        <label asp-for="LoadCapacity">Load Capacity in Kg</label>
        <input class ="form-control" asp-for="LoadCapacity" />
        <span class="text-danger" asp-validation-for="LoadCapacity"></span>
    </div>
    <div class="form-group">
        <label asp-for="FuelUsagePerKM">Fuel Usage Liters/KM</label>
        <input class ="form-control" asp-for="FuelUsagePerKM" />
        <span class="text-danger" asp-validation-for="FuelUsagePerKM"></span>
    </div>
    <div class="form-group">
        <label asp-for="FlightRegion"></label>
        <input class ="form-control" asp-for="FlightRegion" />
        <span class="text-danger" asp-validation-for="FlightRegion"></span>
    </div>
     <div class="form-group">
        <label asp-for="ConstructionYear"></label>
        <input class ="form-control" asp-for="ConstructionYear" />
        <span class="text-danger" asp-validation-for="ConstructionYear"></span>
    </div>
    <div class="form-group">
        <label asp-for="AirMiles">Km in the Air for this Airport</label>
        <input class ="form-control" asp-for="AirMiles" />
        <span class="text-danger" asp-validation-for="AirMiles"></span>
    </div>
    <div class="form-group" hidden="hidden">
        <label asp-for="FlightHours"></label>
        <input class ="form-control" asp-for="FlightHours" />
        <span class="text-danger" asp-validation-for="AirMiles"></span>
    </div>
     <div class="form-group" hidden="hidden">
        <label asp-for="NextMainentance"></label>
        <input class ="form-control" asp-for="NextMainentance" />
        <span class="text-danger" asp-validation-for="NextMainentance"></span>
    </div>
       <div class="form-group">
        <input asp-for="IsAvailable"/>
        <label asp-for="IsAvailable">Currently Available?</label>
    
    </div>
    

    <button class="btn btn-secondary" type="submit" onclick="message()" style="margin-top:50px;margin-left:40%;width:400px;">Create</button> 
</form>

<script type="text/javascript">
        function message()
        {
            Swal.fire({                   
                    position: 'center',
                    icon: 'success',
                    title: 'Plane Added',
                    showConfirmButton: false,
                    timer: 1500                 
                    });
        }
    </script>

Views/Plane/Delete.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    @model PlaneDeleteViewModel
    
}

 <head>
    <link rel="stylesheet" href="~/css/Detailplaneair.css" asp-append-version="true" />
</head>

<div style="padding-top:200px;"></div>
<div class="peoples-visit dining-padding-top">           
            <div class="single-visit left-img">
                <div class="container">
                    <div class="row justify-content-end">
                        <div class="col-lg-8">
                            <div class="visit-caption" style="background-color:#ce9244;">
                                <span>Delete @Model.PlaneNr?</span>
                                <ul>                                                                       
                                    <br/>
                                    <li>@Model.PlaneNr</li>                                                                      
                                    <li>@Model.CurrentAirline.Name</li>
                                    <li>@Model.Manufacturer</li>
                                    <li>@Model.Type</li>                                    
                                </ul>
                                <br />
                                <h1>Delete this Plane?</h1>
                                <br />
                                 <a class="genric-btn info-border circle arrow" onclick="message()" asp-controller="Plane" asp-action="DeleteConfirm" asp-route-ID="@Model.PlaneNr" style="margin-left:10px;">Yes<span class="lnr lnr-arrow-right"></span></a>
                                 <a class="genric-btn danger-border circle arrow" asp-controller="Plane" asp-action="Index" style="margin-left:10px;">No<span class="lnr lnr-arrow-right"></span></a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

  
    <script type="text/javascript">
        function message()
        {
            Swal.fire({                   
                    position: 'center',
                    icon: 'error',
                    title: 'Plane Deleted',
                    showConfirmButton: false,
                    timer: 1500                   
                    });
        }
    </script>

Views/Plane/Detail.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    string path = @Model.SeatDiagramPic.Remove(0,1);
    path = path.Insert(0, "..");
}
@model PlaneDetailViewModel


 <head>
    <link rel="stylesheet" href="~/css/Detailplane.css" asp-append-version="true" />            
</head>
<div style="padding-top:200px;"></div>
<div class="peoples-visit dining-padding-top">           
            <div class="single-visit left-img">               
                <div class="container">
                    <div class="row justify-content-end">
                        <div class="col-lg-8">
                            <div class="visit-caption" style="background-color:#36b1ad;">
                                <span>Details for @Model.PlaneNr</span>
                                <form asp-controller="Plane" asp-action="Create" method="post">
                                <div class="form-group" >
                                    <label asp-for="Type"></label>
                                    <input class ="form-control" asp-for="Type" readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="Type"></span>
                                </div>
    
                                <div class="form-group">
                                    <label asp-for="Manufacturer" ></label>
                                    <input class ="form-control" asp-for="Manufacturer" readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="Manufacturer"></span>
                                </div>                               
                                <div class="form-group">
                                    <label asp-for="PassengerCapacity"></label>
                                    <input class ="form-control" asp-for="PassengerCapacity" readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="PassengerCapacity"></span>
                                </div> 
                                <div class="form-group">
                                    <label asp-for="FirstClassCapacity"></label>
                                    <input class ="form-control" asp-for="FirstClassCapacity" readonly="readonly" />
                                    <span class="text-danger" asp-validation-for="FirstClassCapacity"></span>
                                </div>
                                <div class="form-group">
                                    <label asp-for="FuelCapacity">Fuel Capacity in Liters</label>
                                    <input class ="form-control" asp-for="FuelCapacity" readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="FuelCapacity"></span>
                                </div>
    
                                <div class="form-group">
                                    <label asp-for="LoadCapacity">Load Capacity in Kg</label>
                                    <input class ="form-control" asp-for="LoadCapacity" readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="LoadCapacity"></span>
                                </div>
                                <div class="form-group">
                                    <label asp-for="FuelUsagePerKM">Fuel Usage Liters/KM</label>
                                    <input class ="form-control" asp-for="FuelUsagePerKM" readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="FuelUsagePerKM"></span>
                                </div>
                                <div class="form-group">
                                    <label asp-for="FlightRegion"></label>
                                    <input class ="form-control" asp-for="FlightRegion" readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="FlightRegion"></span>
                                </div>
                                 <div class="form-group">
                                    <label asp-for="ConstructionYear"></label>
                                    <input class ="form-control" asp-for="ConstructionYear"  readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="ConstructionYear"></span>
                                </div>
                                <div class="form-group">
                                    <label asp-for="AirMiles">Km in the Air for this Airport</label>
                                    <input class ="form-control" asp-for="AirMiles"  readonly="readonly"/>
                                    <span class="text-danger" asp-validation-for="AirMiles"></span>
                                </div>
                               
                                   <div class="form-group">
                                    <input asp-for="IsAvailable"  readonly="readonly"/>
                                    <label asp-for="IsAvailable">Currently Available?</label>  
                                </div>     
                                @if (User.IsInRole("Airline"))
                                {
                                    <a class="genric-btn info-border circle" asp-action="Index" asp-controller="Airline">Back</a>
                                }
                                else if(User.IsInRole("Admin"))
                                {
                                    <a class="genric-btn info-border circle" asp-action="List" asp-controller="Plane">Back</a>
                                }
                            </form>
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
 

Views/Plane/Type.cshtml
@using AirWaze.Components
@{
    ViewData["Title"] = "Home Page";
}

<head>
@* <script src="_content/Blazor.Extensions.Canvas/blazor.extensions.canvas.js"></script>*@

 <script src="_framework/blazor.server.js"></script>
</head>

@*Hierboven links naar de respective stylesheets en inladen van de scripts en extensions voor de Blazor Component.
Hieronder wordt hij gecalled in de main @RenderBody metho in _layout. Blazorscript dient daar ook toegevoegd te worden.
Ook aanpassen in program.cs en rekening houden met routing, zeker bij use buiten homecontroller*@

@(await Html.RenderComponentAsync<Planetypepicker>(RenderMode.Server))